#include once "vbcompat.bi"
#define MAX_X     60
#define MAX_Y     60
#define MAX_STEIN 20

#if __FB_UNIX__
  #define SLASH "/"
#else
  #define SLASH "\"
#endif

enum Fehler explicit
  keinFehler = 0, nichtGefunden, falscheDateigroesse, falscheSteingroesse, falscheFeldgroesse
end enum
enum Feldtyp explicit
  leer = 0, gesucht, fest, korrekt, falsch, sperrLeer, sperrGesucht, gesperrt
end enum

type mustertyp
  as integer feld(2,2)
end type

dim shared muster(MAX_STEIN) as mustertyp, levelname as string
dim shared as integer feld(MAX_X, MAX_Y), anzSteine, hilfe = -1
dim shared as integer farben(...) = { &hff0000, &h00ffff, &h00ff00, &h0000ff, &hffff00 }
dim as integer nr, posX = MAX_X\2-1, posY = 1, level = 0
dim as string taste

declare function feldLaden(nr as integer) as integer
declare sub feldZeichnen
declare sub hilfsleiste(x as integer, y as integer)
declare sub musterZeichnen(stein as integer, x as integer, y as integer, opt as integer = 1)
declare sub steinZeichnen(x as integer, y as integer, farbe as integer)
declare sub rekursivEntsperren(x as integer, y as integer)

randomize
screenres MAX_X*10 + 200, MAX_Y*10, 32

do
  ' Spiel vorbereiten
  level += 1
  if feldLaden(level) <> Fehler.keinFehler then end
  feldZeichnen

  ' Spiel starten
  nr = int(rnd*anzSteine) + 1
  musterZeichnen nr, posX, posY
  if hilfe then hilfsleiste posX, posY
  
  do
    sleep 1
    taste = inkey
    if taste = chr(255, 72) andalso posY = 1 then continue do
    if taste = chr(255, 75) andalso posX = 1 then continue do
    if taste = chr(255, 77) andalso posX = MAX_X-4 then continue do
    if taste = chr(255, 80) andalso posY = MAX_Y-4 then continue do
    select case taste
      case chr(255, 72), chr(255, 75), chr(255, 77), chr(255, 80)
        ' bewegen
        if hilfe then hilfsleiste posX, posY
        musterZeichnen nr, posX, posY, 0
        if (taste = chr(255, 72) or taste = chr(255, 80)) then
          if posX > 1 and posX < MAX_X-4 then
            posX += iif(posX < MAX_X\2-1, -1, 1)
          else
            posY += iif(taste = chr(255, 72), -1, 1)
          end if
        else
          if posY > 1 and posY < MAX_Y-4 then
            posY += iif(posY < MAX_Y\2-1, -1, 1)
          else
            posX += iif(taste = chr(255, 75), -1, 1)
          end if
        end if
        musterZeichnen nr, posX, posY
        if hilfe then hilfsleiste posX, posY
      case chr(13)
        'drehen
        if hilfe then hilfsleiste posX, posY
        musterZeichnen nr, posX, posY, 0
        with muster(nr)
          dim as integer temp(2, 2) = { {.feld(2, 0), .feld(1, 0), .feld(0, 0)}, _
                                        {.feld(2, 1), .feld(1, 1), .feld(0, 1)}, _
                                        {.feld(2, 2), .feld(1, 2), .feld(0, 2)}  }
          for x as integer = 0 to 2 : for y as integer = 0 to 2
            .feld(x, y) = temp(x, y)
          next : next
        end with
        musterZeichnen nr, posX, posY
        if hilfe then hilfsleiste posX, posY
      case " "
        ' losschicken
        dim as integer rx = 0, ry = 0, ax = posX, ay = posY, pruefe(2) = {-1, -1, -1}, fund = 0
        ' ueberpruefe Naehe zum Rand
        if (posX < 7 or posX >  MAX_X-10) and (posY < 7 or posY >  MAX_Y-10) then beep : continue do
        ' ueberpruefe, ob / wo der Stein aufgefangen wird
        if posX = 1 then
          rx = 1
          for y as integer = 0 to 2 : for x as integer = 2 to 0 step -1
            if muster(nr).feld(x, y) then pruefe(y) = x : exit for
          next : next
        elseif posX = MAX_X-4 then
          rx = -1
          for y as integer = 0 to 2 : for x as integer = 0 to 2
            if muster(nr).feld(x, y) then pruefe(y) = x : exit for
          next : next
        elseif posY = 1 then
          ry = 1
          for x as integer = 0 to 2 : for y as integer = 2 to 0 step -1
            if muster(nr).feld(x, y) then pruefe(x) = y : exit for
          next : next
        else
          ry = -1
          for x as integer = 0 to 2 : for y as integer = 0 to 2
            if muster(nr).feld(x, y) then pruefe(x) = y : exit for
          next : next
        end if
        do
          ax += rx
          ay += ry
          for i as integer = 0 to 2
            if pruefe(i) < 0 then continue for
            if rx = 1  and feld(ax+pruefe(i)+1, ay+i) > Feldtyp.gesucht then fund = ax : exit do
            if rx = -1 and feld(ax+pruefe(i)-1, ay+i) > Feldtyp.gesucht then fund = ax : exit do
            if ry = 1  and feld(ax+i, ay+pruefe(i)+1) > Feldtyp.gesucht then fund = ay : exit do
            if ry = -1 and feld(ax+i, ay+pruefe(i)-1) > Feldtyp.gesucht then fund = ay : exit do
          next
        loop until ax+rx < 1 or ax+rx > MAX_X-4 or ay+ry < 1 or ay+ry > MAX_Y-3
        if fund > 5 and fund < iif(rx <> 0, MAX_X-8, MAX_Y-8) then
          ' Stein kann losgeschickt werden
          if hilfe then hilfsleiste posX, posY
          ax = posX
          ay = posY
          do
            musterZeichnen nr, ax, ay, 0
            ax += rx
            ay += ry
            if (rx andalso ax = fund) orelse (ry andalso ay = fund) then exit do
            musterZeichnen nr, ax, ay
            sleep 50, 1
          loop
          musterZeichnen nr, ax, ay, 2
          ' Siegbedingung pruefen
          for x as integer = 1 to MAX_X : for y as integer = 1 to MAX_Y
            select case as const feld(x, y)
              case Feldtyp.leer    : feld(x, y) = Feldtyp.sperrLeer
              case Feldtyp.gesucht : feld(x, y) = Feldtyp.sperrGesucht
            end select
          next : next
          rekursivEntsperren 1, 1
          fund = 0  ' Suche nach noch unbelegten Feldern
          for x as integer = 1 to MAX_X : for y as integer = 1 to MAX_Y
            if feld(x, y) = Feldtyp.gesucht then fund += 1
            if feld(x, y) = Feldtyp.sperrGesucht then
              feld(x, y) = Feldtyp.gesperrt
              steinZeichnen x, y, &hffffff
            end if
          next : next
          if fund = 0 then print "*** LEVEL " & level & " ABGESCHLOSSEN! ***" : getkey : exit do
          ' neuen Stein auswaehlen
          nr = int(rnd*anzSteine)+1
          musterZeichnen nr, posX, posY
          if hilfe then hilfsleiste posX, posY
        else
          beep
        end if
    end select
  loop until taste = chr(27)
loop until taste = chr(27)
  
function feldLaden(nr as integer) as integer
  dim f as integer = freefile, zeile as string
  if open("level" & SLASH & "level" & format(nr, "000") & ".txt" for input as #f) then
    return Fehler.nichtGefunden
  end if
  line input #f, levelname
  ' Spielsteine
  for y as integer = 0 to 2
    if eof(f) then close #f : return Fehler.falscheDateigroesse
    line input #f, zeile
    if y = 0 then
      if len(zeile) mod 4 <> 3 then close #f : return Fehler.falscheSteingroesse
      anzSteine = len(zeile)\4 +1
      if anzSteine > MAX_STEIN then close #f : return Fehler.falscheSteingroesse
    else
      if len(zeile) <> anzSteine*4 - 1 then close #f : return Fehler.falscheSteingroesse
    end if
    for nr as integer = 0 to anzSteine - 1
      for x as integer = 0 to 2
        if zeile[nr*4 + x] = 49 then muster(nr+1).feld(x, y) = 1 else muster(nr+1).feld(x, y) = 0
      next
    next
  next
  for y as integer = 21 to MAX_Y - 20
    if eof(f) then close #f : return Fehler.falscheDateigroesse
    line input #f, zeile
    if len(zeile) <> MAX_X - 40 then close #f : return Fehler.falscheFeldgroesse
    for x as integer = 21 to MAX_X - 20
      feld(x, y) = zeile[x-21] - 48
    next
  next
  close #f
  return Fehler.keinFehler
end function

sub feldZeichnen
  dim as integer farbe
  screenlock
  for y as integer = 0 to MAX_Y-1
    steinZeichnen 0, y, &hbbbbbb
    steinZeichnen MAX_X-1, y, &hbbbbbb
  next
  for x as integer = 1 to MAX_Y-2
    steinZeichnen x, 0, &hbbbbbb
    steinZeichnen x, MAX_Y-1, &hbbbbbb
  next
  for x as integer = 0 to 1 : for y as integer = 0 to 1
    steinZeichnen 5+x, 5+y, &hbbbbbb
    steinZeichnen 5+x, MAX_Y-6-y, &hbbbbbb
    steinZeichnen MAX_X-6-x, 5+y, &hbbbbbb
    steinZeichnen MAX_X-6-x, MAX_Y-6-y, &hbbbbbb
  next : next
  for x as integer = 21 to MAX_X - 20
    for y as integer = 21 to MAX_Y - 20
      select case feld(x, y)
        case Feldtyp.leer    : farbe = 0
        case Feldtyp.fest    : farbe = &hbbbbbb
        case Feldtyp.gesucht : farbe = &h333333
      end select
      steinZeichnen x, y, farbe
    next
  next
  screenunlock
end sub

sub hilfsleiste(x as integer, y as integer)
  if (x < 7 or x >  MAX_X-10) and (y < 7 or y >  MAX_Y-10) then exit sub
  dim as any ptr puffer
  if x = 1 or x = MAX_X-4 then
    puffer = imagecreate ((MAX_X-2)*10, 30, &h101010)
    put (210, y*10), puffer, xor
  else
    puffer = imagecreate (30, (MAX_Y-2)*10, &h101010)
    put (x*10+200, 10), puffer, xor
  end if
  imagedestroy puffer
end sub

sub musterZeichnen(stein as integer, x as integer, y as integer, opt as integer = 1)
  ' stein: Steinnummer
  ' x, y:  Position
  ' opt:   0=loeschen; 1=normal; 2=befestigen
  if x < 1 or y < 1 or x > MAX_X-4 or y > MAX_Y-4 or stein < 0 or stein > anzSteine then exit sub
  with muster(stein)
    dim as integer farbe
    for i as integer = 0 to 2 : for k as integer = 0 to 2
      if .feld(i, k) = 1 then
        select case as const opt
          case 0
            if feld(x+i, y+k) = Feldtyp.gesucht then farbe = &h333333 else farbe = 0
          case 1
            farbe = farben(stein mod (ubound(farben)+1))
          case 2
            if feld(x+i, y+k) = Feldtyp.gesucht then
              farbe = &hbbbbbb
              feld(x+i, y+k) = Feldtyp.korrekt
            else
              farbe = farben(stein mod (ubound(farben)+1))
              feld(x+i, y+k) = Feldtyp.falsch
            end if
        end select
        steinZeichnen x+i, y+k, farbe
      end if
    next : next
  end with
end sub

sub rekursivEntsperren(x as integer, y as integer)
  if x < 1 or y < 1 or x > MAX_X-1 or y > MAX_Y-1 then exit sub
  if feld(x, y) = Feldtyp.sperrLeer then
    feld(x, y) = Feldtyp.leer
    rekursivEntsperren x-1, y
    rekursivEntsperren x+1, y
    rekursivEntsperren x, y-1
    rekursivEntsperren x, y+1
  elseif feld(x, y) = Feldtyp.sperrGesucht then
    feld(x, y) = Feldtyp.gesucht
    rekursivEntsperren x-1, y
    rekursivEntsperren x+1, y
    rekursivEntsperren x, y-1
    rekursivEntsperren x, y+1
  end if
end sub

sub steinZeichnen(x as integer, y as integer, farbe as integer)
  line (x*10+201, y*10+1)-step (8, 8), farbe, BF
  if feld(x, y) = Feldtyp.gesperrt then
    line (x*10+201, y*10+1)-step (8, 8), 0
    line (x*10+209, y*10+1)-step (-8, 8), 0
  end if
end sub
